
#include <QtGui>

#include "Q7BProjectWindow.h"

/*
void Q7BProjectWindow::PerformOpenFile(QString sFilePath)
{
}
*/
void Q7BProjectWindow::PerformOpenProject(QString sFilePath) // project
{
  tw->clear();

   QStringList slForms; slForms << "Forms";// << "c:\\Form1.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form" << "c:\\Form2.Form";
  QStringList slClasses; slClasses << "Classes";// << "c:\\Class1.QWidget.Class" << "c:\\Class2.Class";
  QStringList slModules; slModules << "Modules";// << "c:\\Module1.Module" << "c:\\Module2.Module";
  QStringList ui; ui << "*.ui.dummy";// << "c:\\test3.ui" << "c:\\test4.ui";
  //QStringList cpp; cpp << "cpp";// << "c:\\test3.cpp" << "c:\\test4.cpp";
  //QStringList Copy; Copy << "Copy" << "c:\\test3" << "c:\\test4";
  //QStringList Resources; Resources << "Resources" << "c:\\test3" << "c:\\test4";  

   QDir thisDir( sFilePath );
   QFileInfoList files = thisDir.entryInfoList();

     if ( files.size() ) {

       QFileInfo fi;
       for (int i = 0; i < files.size(); ++i) {
         fi = files.at(i);

         QString s = fi.absoluteFilePath();

         if (fi.fileName() == "." || fi.fileName() == "..") continue;
         if (fi.isFile()){
           if (fi.fileName().endsWith("Module.q7b")){
             slModules << fi.absoluteFilePath();
           } else if (fi.fileName().endsWith("Form.q7b")){
             slForms << fi.absoluteFilePath();
           } else if (fi.fileName().endsWith(".ui")){
             ui << fi.absoluteFilePath();
           } else if (fi.fileName().endsWith(".q7b")){
             slClasses << fi.absoluteFilePath();
           }
         }
       }
     }


  QStringList slAll; slAll << slForms; slAll << slClasses; slAll << slModules; slAll << ui;// slAll << cpp; slAll << Copy; slAll << Resources;

  tw->setRowCount(slAll.size());
  
int nCount = 0;
    for (int i = 0; i < tw->rowCount(); i++){
    
   
    
    if (i == 0 || i == slForms.size() || i == slForms.size() + slClasses.size() || i == slForms.size() + slClasses.size() + slModules.size() || i == slForms.size() + slClasses.size() + slModules.size() + ui.size()){// || i == slForms.size() + slClasses.size() + ui.size() + cpp.size() || i == slForms.size() + slClasses.size() + ui.size() + cpp.size() + Copy.size() || i == slForms.size() + slClasses.size() + ui.size() + cpp.size() + Copy.size() + Resources.size()){

      if (i == slForms.size() - 1 && slForms.size() < 2) continue;
      if (i == slForms.size() + slClasses.size() - 1 && slClasses.size() < 2) continue;
      if (i == slForms.size() + slClasses.size() + slModules.size() - 1 && slModules.size() < 2) continue;
      if (i == slForms.size() + slClasses.size() + slModules.size() + ui.size() - 1 && ui.size() < 2) continue;

      QTableWidgetItem *item = new QTableWidgetItem();
      item->setText(QFileInfo(slAll.at(i)).completeBaseName());    

      QFont f = item->font();
      f.setBold(true);
      item->setFont(f);
      item->setFlags(0);
      item->setForeground(QBrush(Qt::white));
      item->setBackgroundColor(Qt::gray);
      tw->setItem(nCount, 0, item);
      nCount++;
      
      
    } else {


     // 
      QTableWidgetItem *item = new QTableWidgetItem();



      bool b = false;

      if (i > slForms.size() + slClasses.size() + slModules.size()){
        item->setIcon(QIcon(":/Resources/ti_qtdesigner.png"));//C:\\Users\\Bernd\\Desktop\\objb_q7basic\\Q7Basic\\Resources\\

      } else if (i > slForms.size() + slClasses.size()){
        item->setIcon(QIcon(":/Resources/module.png"));
        
      } else if (i > slForms.size()){
        b = true;

        if (QFileInfo(slAll.at(i)).completeBaseName().endsWith("Global.QObject")){
          item->setIcon(QIcon(":/Resources/ti_global.png"));  
        } else if (QFileInfo(slAll.at(i)).completeBaseName().endsWith(".QMainWindow")){
          item->setIcon(QIcon(":/Resources/QMainWindow.png"));  
        } else if (QFileInfo(slAll.at(i)).completeBaseName().endsWith(".QApplication")){
          item->setIcon(QIcon(":/Resources/QApplication.png"));  
        } else if (QFileInfo(slAll.at(i)).completeBaseName().endsWith(".QSystemTrayIcon")){
          item->setIcon(QIcon(":/Resources/QSystemTrayIcon.png"));  
        } else if (QFileInfo(slAll.at(i)).completeBaseName().endsWith(".QObject")){
          item->setIcon(QIcon(":/Resources/ti_code.png"));  
        } else if (QFileInfo(slAll.at(i)).completeBaseName().endsWith(".Class")){
          item->setIcon(QIcon(":/Resources/ti_code.png"));  
          b = false;
        } else {
          item->setIcon(QIcon(":/Resources/widget.png"));  
        }
        

      } else {
        item->setIcon(QIcon(":/Resources/ti_form.png"));
      }

      if (b){
        item->setText(QFileInfo(slAll.at(i)).completeBaseName());    
      } else {
        item->setText(QFileInfo(slAll.at(i)).baseName());    
      }
      

      item->setFlags(Qt::ItemIsSelectable | Qt::ItemIsEnabled);
      item->setData(Qt::UserRole, slAll.at(i));
      tw->setItem(nCount, 0, item);
      nCount++;
    }
    
/*
    QTableWidgetItem *item2 = new QTableWidgetItem();
    item2->setText(slAll.at(i));    
    tw->setItem(i, 1, item2);*/
  }

    tw->setRowCount(nCount);

    currentprojectname->setText(QFileInfo(sFilePath).completeBaseName());

    tree->setRootIndex(model->index(sFilePath));

}

Q7BProjectWindow::Q7BProjectWindow(QWidget *parent) : QWidget (parent)
{
  
  tw = new QTableWidget();
  tw->setColumnCount(2);
  tw->setContextMenuPolicy(Qt::CustomContextMenu);
  tw->setSelectionMode(QAbstractItemView::SingleSelection);

  //tw->horizontalHeader()->resizeSection(0, 100);
  //tw->horizontalHeader()->resizeSection(1, 450);
 // tw->horizontalHeader()->hideSection(tw->horizontalHeader()->logicalIndex(1));
  tw->horizontalHeader()->hideSection(1);
 // tw->setColumnHidden(1, true);
  tw->horizontalHeader()->setStretchLastSection(true);
  tw->verticalHeader()->hide();
  tw->horizontalHeader()->hide();

 // tw->showMaximized();
 
  
  //tw->setColumnWidth(1, 400);
  //tw->setItemDelegate(new TableDelegate(this));


  /*
  QTableWidgetItem * t = new QTableWidgetItem("Name");
  t->setStatusTip("setStatusTip");
  t->setToolTip("setToolTip");
  QFont f = t->font();
  f.setBold(true);
  t->setFont(f);
  tw->setItem(0, 0, t);

  t = new QTableWidgetItem(" TEST         ");
  tw->setItem(0, 1, t);
 // tw->openPersistentEditor(t);
 */

  /*
  connect(tw, SIGNAL(cellChanged (int, int)), this, SLOT(cellChanged(int, int)));
  connect(tw, SIGNAL(cellActivated (int, int)), this, SLOT(cellActivated(int, int)));
  connect(tw, SIGNAL(cellClicked (int, int)), this, SLOT(cellActivated(int, int)));
  connect(tw, SIGNAL(currentCellChanged (int, int, int, int)), this, SLOT(currentCellChanged(int, int, int, int)));

  tw->setSelectionMode(QAbstractItemView::NoSelection);
  tw->setEditTriggers(QAbstractItemView::CurrentChanged);*/

 // tw->setRowHeight(0, 20);
  /*
  for (int i = 0; i < ROWC - 1; i++){
    t = new QTableWidgetItem(QString("Name %1 ffffffffffffffffff").arg(i));
	
    tw->setItem(i + 1, 0, t);

    tw->setRowHeight(i + 1, 20);
  }*/

 
  tw->setShowGrid(false);
  tw->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);

  tw->setStyleSheet(""
   // "QTableWidget {selection-background-color: qlineargradient(x1: 0, y1: 0, x2: 0.5, y2: 0.5, stop: 0 #FF92BB, stop: 1 white);}"
    "QTableWidget::item:hover { background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #FAFBFE, stop: 1 #DCDEF1);}"
 "QTableWidget::item:selected {border: 1px solid #6a6ea9;}"
 "QTableWidget::item:selected:!active {background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #ABAFE5, stop: 1 #8588B2);}"
 "QTableWidget::item:selected:active { background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #6a6ea9, stop: 1 #888dd9);}"


    // "QTableWidget { selection-color: qlineargradient(x1: 0, y1: 0, x2: 0.5, y2: 0.5, stop: 0 #0092BB, stop: 1 white);}"    
   ""
    );


  QVBoxLayout *j = new QVBoxLayout();
  j->setMargin(0);
  j->setSpacing(0);
  this->setLayout(j);

  currentprojectname = new QLabel("");
  currentprojectname->setFixedHeight(32);
  currentprojectname->setIndent(5);
  QFont f = currentprojectname->font();
  f.setBold(true);
  currentprojectname->setFont(f);
#ifdef MAC
  f = currentprojectname->font(); f.setPixelSize(10); currentprojectname->setFont(f); 
#endif

  j->addWidget(currentprojectname);
  //j->addWidget(tw);
  
 

     model = new QFileSystemModel;
     model->setReadOnly(true);
     model->setRootPath(QDir::currentPath());
     //model->setSorting(QDir::DirsFirst | QDir::Name);


     tree = new QTreeView();
     tree->setModel(model);

    
     //tree->header()->setClickable(true);

    tree->setColumnHidden( 1, true );
    tree->setColumnHidden( 2, true );
    tree->setColumnHidden( 3, true );

   // tree->setWindowTitle(QObject::tr("Dir View:")+QDir::homePath());
    //tree->resize(640, 480);
    //tree->show();

    connect(tree, SIGNAL( doubleClicked(const QModelIndex&) ),
            this, SLOT( tree_doubleClicked(const QModelIndex&) ) );
    

  //  connect(tree, SIGNAL(itemDoubleClicked(QTableWidgetItem*)), this, SLOT(tree_itemDoubleClicked(QTableWidgetItem*)));
   // j->addWidget(tree);

  //j->addWidget(new QPushButton(tr("Resources")));

  //connect(tw, SIGNAL(itemDoubleClicked(QTableWidgetItem*)), this, SLOT(tw_itemDoubleClicked(QTableWidgetItem*)));
  //connect(tw, SIGNAL(itemActivated(QTableWidgetItem*)), this, SLOT(tw_itemActivated(QTableWidgetItem*)));
  connect(tw, SIGNAL(currentItemChanged(QTableWidgetItem*,QTableWidgetItem*)), this, SLOT(tw_currentItemChanged(QTableWidgetItem*,QTableWidgetItem*)));
 // connect(tw, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(tw_customContextMenuRequested(const QPoint &)));

  

  QTabWidget *tb = new QTabWidget();

  tb->addTab(tw, "Source Codes && GUI");
  tb->addTab(tree, "File Browser");

  j->addWidget(tb);
/*
  QToolBar *tb = new QToolBar(this); j->addWidget(tb);



  QActionGroup *ag = new QActionGroup(this);
  ag->setExclusive(true);

  QAction *a;
  a = tb->addAction(QObject::tr("All"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Forms"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Classes"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Modules"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Tables"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Queries"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Reports"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Menubars"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Toolbars"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Images"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);
  a = tb->addAction(QObject::tr("Others"), this, SLOT(Show())); a->setActionGroup(ag); a->setCheckable(true);

 // QAction *aType = tb->addAction(QObject::tr("Type"), this, SLOT(actionType())); aType->setActionGroup(ag); aType->setCheckable(true);
  { // add extra space
    QWidget *ww = new QWidget();
    QSizePolicy sp;
    sp.setHorizontalPolicy(QSizePolicy::Expanding);
    ww->setSizePolicy(sp);
    tb->addWidget(ww);
  }*/

  //ShowAll();
// startTimer(500);

  //PerformOpenProject("C:\\Users\\Bernd\\Desktop\\objb_q7basic\\Q7Basic");
}
/*
void Q7BProjectWindow::timerEvent(QTimerEvent * e)
{
  static bool b = false;
  
  if (b){
    PerformOpenProject("C:\\Users\\Bernd\\Desktop\\objb_q7basic\\Q7Basic");
  } else {
    PerformOpenProject("C:\\Users\\Bernd\\Desktop\\MyProject99");
  }
  b = !b;
  
}*/

void Q7BProjectWindow::PerformSelect(QString sFilePath)
{

  QString s = QFileInfo(sFilePath).fileName();
  if (s.endsWith(".q7b")){
    s = s.left(s.indexOf(".q7b"));
  //  QMessageBox::information(0, "PerformSelect", s);
    QList<QTableWidgetItem *> l = tw->findItems(s, Qt::MatchExactly);

    if (l.size() > 0){
      tw->setCurrentItem(l.at(0));
    }
  }

}

void Q7BProjectWindow::tree_doubleClicked(const QModelIndex &index)
{

    //if(index.isValid())
    {
        //Verzeichnisse
    
        if(model->fileInfo(index).isFile())
        {

            
            QString fileName =  model->filePath(index);
            //QMessageBox::information(0, "tw_itemDoubleClicked", fileName);

            if (fileName.endsWith(".q7b")){
              emit Open(fileName);
            } else {
              QDesktopServices::openUrl( QUrl("file:///" + fileName) );
            }
          
        }
      }
}
/*
void Q7BProjectWindow::tw_itemDoubleClicked(QTableWidgetItem *item)
{
    QMessageBox::information(0, "tw_itemDoubleClicked", item->text());


}
*/

//void Q7BProjectWindow::tw_itemActivated(QTableWidgetItem *item)
//void tw_currentItemChanged ( QTreeWidgetItem * current, QTreeWidgetItem * previous );

void Q7BProjectWindow::tw_currentItemChanged ( QTableWidgetItem * current, QTableWidgetItem * previous )
{
  if (current == 0) return;

  //static bool bLock = false;

  //if (bLock == false)
  {
  QString fileName = current->data(Qt::UserRole).toString();
     // QMessageBox::information(0, "tw_itemActivated", fileName);

      if (fileName.endsWith(".q7b")){
        emit Open(fileName);
      } else {
       /* if (previous){
          bLock = true;
       // tw->clearSelection();
          tw->setCurrentItem(previous);
          
          
        }*/
        QDesktopServices::openUrl( QUrl("file:///" + fileName) );
      }
  }
//  bLock = false;
}
/*
void Q7BProjectWindow::tw_customContextMenuRequested ( const QPoint & pos )
{
  //if (!cutAvailable()) return;

  QMenu contextMenu(this);

  QAction *a = 0;

  a = contextMenu.addAction(tr("&Open"), (QWidget *) this, SLOT(event_OPEN()));
  QFont f = a->font();
  f.setBold(true);
  a->setFont(f);

  QTableWidgetItem *item = tw->currentItem();
  
  item = tw->item(tw->currentRow(), 1);

  QString s = item->text();

  if (
    s.endsWith(".Table", Qt::CaseInsensitive)
    ){
    a = contextMenu.addAction(tr("&Data"), (QWidget *) this, SLOT(event_OPEN2()));
  }  
  else if (
    s.endsWith(".Form", Qt::CaseInsensitive)
    || s.endsWith(".Report", Qt::CaseInsensitive)
    || s.endsWith(".MenuBar", Qt::CaseInsensitive)
    || s.endsWith(".ToolBar", Qt::CaseInsensitive)
    ){
    a = contextMenu.addAction(tr("&Source Code"), (QWidget *) this, SLOT(event_OPEN2()));
  }  

  contextMenu.addSeparator();


  a = contextMenu.addAction(tr("Cu&t"), (QWidget *) this, SLOT(event_EDIT_CUT()), QKeySequence("CTRL+X"));
  a = contextMenu.addAction(tr("&Copy"), (QWidget *) this, SLOT(event_EDIT_COPY()), QKeySequence("CTRL+C"));
  a = contextMenu.addAction(tr("&Paste"), (QWidget *) this, SLOT(event_EDIT_PASTE()), QKeySequence("CTRL+V"));

  //a->setEnabled(!EXTERN_my_mainwindow->sCut.isEmpty() || !EXTERN_my_mainwindow->sCopy.isEmpty());

  contextMenu.addSeparator();
  a = contextMenu.addAction(tr("R&ename"), (QWidget *) this, SLOT(event_RENAME()));
  contextMenu.addSeparator();

  a = contextMenu.addAction(tr("&Delete"), (QWidget *) this, SLOT(event_EDIT_DELETE()));    

  contextMenu.exec(QCursor::pos());
}*/